/// <reference types="react" />
import './index.scss';
declare type ProcessType = 'shadow' | 'ellipsis';
interface TextProcessProps {
    type?: ProcessType;
    isRenderShowAllDOM?: boolean;
    unfoldButtonText?: string | JSX.Element | JSX.Element[];
    foldButtonText?: string | JSX.Element | JSX.Element[];
    buttonBeforeSlot?: string | JSX.Element | JSX.Element[];
    buttonClassName?: string;
    buttonStyle?: React.CSSProperties;
    text: string;
    lineHeight?: number;
    ellipsisLineClamp?: number;
    className?: string;
    style?: React.CSSProperties;
    isShowAllContent?: boolean;
    isMustButton?: boolean;
    isMustNoButton?: boolean;
    shadowInitBoxShowH?: number;
    onClick?: () => void;
    getIsFold?: (v: boolean) => void;
}
declare function TextOverflowProcessor(props: TextProcessProps): JSX.Element;
declare namespace TextOverflowProcessor {
    var defaultProps: {
        type: string;
        isRenderShowAllDOM: boolean;
        unfoldButtonText: string;
        foldButtonText: string;
        buttonBeforeSlot: undefined;
        buttonClassName: string;
        buttonStyle: {};
        text: string;
        lineHeight: number;
        ellipsisLineClamp: number;
        className: string;
        style: {};
        isShowAllContent: boolean;
        isMustButton: boolean;
        isMustNoButton: boolean;
        shadowInitBoxShowH: number;
        onClick: null;
        getIsFold: null;
    };
}
declare const _default: import("react").MemoExoticComponent<typeof TextOverflowProcessor>;
export default _default;
